///engine_flags=--language=es6
var scriptName = "SimpleTPAura";
var scriptVersion = 0.7;
var scriptAuthor = "mumy++";

var Color = Java.type("java.awt.Color");
var ArrayList = Java.type("java.util.ArrayList");
var Timer = Java.type("java.util.Timer");
var Executors = Java.type("java.util.concurrent.Executors");
var AtomicInteger = Java.type("java.util.concurrent.atomic.AtomicInteger");
var LiquidBounce = Java.type("net.ccbluex.liquidbounce.LiquidBounce");
var AttackEvent = Java.type("net.ccbluex.liquidbounce.event.AttackEvent");
var EventState = Java.type("net.ccbluex.liquidbounce.event.EventState");
var AntiBot = Java.type("net.ccbluex.liquidbounce.features.module.modules.misc.AntiBot");
var EntityUtils = Java.type("net.ccbluex.liquidbounce.utils.EntityUtils");
var RaycastUtils = Java.type("net.ccbluex.liquidbounce.utils.RaycastUtils");
var RotationUtils = Java.type("net.ccbluex.liquidbounce.utils.RotationUtils");
var ColorUtils = Java.type("net.ccbluex.liquidbounce.utils.render.ColorUtils");
var RenderUtils = Java.type("net.ccbluex.liquidbounce.utils.render.RenderUtils");
var MSTimer = Java.type("net.ccbluex.liquidbounce.utils.timer.MSTimer");
var BlockValue = Java.type("net.ccbluex.liquidbounce.value.BlockValue");
var BoolValue = Java.type("net.ccbluex.liquidbounce.value.BoolValue");
var FloatValue = Java.type("net.ccbluex.liquidbounce.value.FloatValue");
var IntegerValue = Java.type("net.ccbluex.liquidbounce.value.IntegerValue");
var ListValue = Java.type("net.ccbluex.liquidbounce.value.ListValue");
var TextValue = Java.type("net.ccbluex.liquidbounce.value.TextValue");
var Block = Java.type("net.minecraft.block.Block");
var BlockCarpet = Java.type("net.minecraft.block.BlockCarpet");
var BlockDoor = Java.type("net.minecraft.block.BlockDoor");
var BlockFence = Java.type("net.minecraft.block.BlockFence");
var BlockFenceGate = Java.type("net.minecraft.block.BlockFenceGate");
var BlockLadder = Java.type("net.minecraft.block.BlockLadder");
var BlockLiquid = Java.type("net.minecraft.block.BlockLiquid");
var BlockSnow = Java.type("net.minecraft.block.BlockSnow");
var BlockStaticLiquid = Java.type("net.minecraft.block.BlockStaticLiquid");
var BlockTrapDoor = Java.type("net.minecraft.block.BlockTrapDoor");
var BlockWall = Java.type("net.minecraft.block.BlockWall");
var Material = Java.type("net.minecraft.block.material.Material");
var GlStateManager = Java.type("net.minecraft.client.renderer.GlStateManager");
var GameSettings = Java.type("net.minecraft.client.settings.GameSettings");
var KeyBinding = Java.type("net.minecraft.client.settings.KeyBinding");
var EntityLivingBase = Java.type("net.minecraft.entity.EntityLivingBase");
var EntityDragon = Java.type("net.minecraft.entity.boss.EntityDragon");
var EntityGhast = Java.type("net.minecraft.entity.monster.EntityGhast");
var EntityGolem = Java.type("net.minecraft.entity.monster.EntityGolem");
var EntityMob = Java.type("net.minecraft.entity.monster.EntityMob");
var EntitySlime = Java.type("net.minecraft.entity.monster.EntitySlime");
var EntityAnimal = Java.type("net.minecraft.entity.passive.EntityAnimal");
var EntityBat = Java.type("net.minecraft.entity.passive.EntityBat");
var EntitySquid = Java.type("net.minecraft.entity.passive.EntitySquid");
var EntityVillager = Java.type("net.minecraft.entity.passive.EntityVillager");
var EntityPlayer = Java.type("net.minecraft.entity.player.EntityPlayer");
var ItemSword = Java.type("net.minecraft.item.ItemSword");
var C02PacketUseEntity = Java.type("net.minecraft.network.play.client.C02PacketUseEntity");
var C04PacketPlayerPosition = Java.type("net.minecraft.network.play.client.C03PacketPlayer.C04PacketPlayerPosition");
var C05PacketPlayerLook = Java.type("net.minecraft.network.play.client.C03PacketPlayer.C05PacketPlayerLook");
var C07PacketPlayerDigging = Java.type("net.minecraft.network.play.client.C07PacketPlayerDigging");
var C08PacketPlayerBlockPlacement = Java.type("net.minecraft.network.play.client.C08PacketPlayerBlockPlacement");
var C0BPacketEntityAction = Java.type("net.minecraft.network.play.client.C0BPacketEntityAction");
var S08PacketPlayerPosLook = Java.type("net.minecraft.network.play.server.S08PacketPlayerPosLook");
var AxisAlignedBB =  Java.type("net.minecraft.util.AxisAlignedBB");
var BlockPos = Java.type("net.minecraft.util.BlockPos");
var MutableBlockPos = Java.type("net.minecraft.util.BlockPos.MutableBlockPos");
var EnumFacing = Java.type("net.minecraft.util.EnumFacing");
var MathHelper = Java.type("net.minecraft.util.MathHelper");
var Mouse = Java.type("org.lwjgl.input.Mouse");
var GL11 = Java.type("org.lwjgl.opengl.GL11");

let threadPool;

function SimpleTPAura() {

    const setting = {
        float: function (name, def, min, max, object) {
            return object == null ? value.createFloat(name, def, min, max) : new _AdaptedValue(new (Java.extend(FloatValue, object))(name, def, min, max));
        },
        integer: function (name, def, min, max, object) {
            return object == null ? value.createInteger(name, def, min, max) : new _AdaptedValue(new (Java.extend(IntegerValue, object))(name, def, min, max));
        },
        boolean: function (name, def, object) {
            return object == null ? value.createBoolean(name, def) : new _AdaptedValue(new (Java.extend(BoolValue, object))(name, def));
        },
        list: function (name, values, def, object) {
            return object == null ? value.createList(name, values, def) : new _AdaptedValue(new (Java.extend(ListValue, object))(name, values, def));
        },
        text: function (name, def, object) {
            return object == null ? value.createText(name, def) : new _AdaptedValue(new (Java.extend(TextValue, object))(name, def));
        },
        block: function (name, def, object) {
            return object == null ? value.createBlock(name, def) : new _AdaptedValue(new (Java.extend(BlockValue, object))(name, def));
        }
    };

    const settings = {
        delay: setting.integer("Delay", 500, 0, 1000),
        range: setting.float("Range", 40, 0, 128),
        hurtTime: setting.integer("HurtTime", 20, 0, 20),
        priority: setting.list("Priority", ["Armor", "Direction", "Distance", "Health", "HurtTime", "LivingTime"], "HurtTime"),
        secondaryPriority: setting.list("SecondaryPriority", ["Armor", "Direction", "Distance", "Health", "HurtTime", "LivingTime"], "Distance"),
        targetMode: setting.list("TargetMode", ["Select", "Normal", "Switch"], "Normal"),
        targets: setting.integer("Targets", 1, 1, 10),
        autoBlock: setting.list("AutoBlock", ["Off", "Basic", "Static", "Vanilla"], "Off"),
        click: setting.boolean("Click", false),
        swing: setting.boolean("Swing", true),
        criticals: setting.boolean("Criticals", true),
        aimTarget: setting.boolean("AimTarget", true),
        compute: setting.integer("Compute", 2048, 1, 10000),
        blinkDistance: setting.float("BlinkDistance", 5, 0, 10),
        vClip: setting.boolean("VClip", true),
        throughWalls: setting.boolean("ThroughWalls", true),
        spoofGround: setting.boolean("SpoofGround", true),
        returnTrip: setting.boolean("ReturnTrip", true),
        lagTryReturn: setting.boolean("LagTryReturn", true),
        tryReturnDelay: setting.integer("TryReturnDelay", 500, 0, 1000),
        limitedLag: setting.integer("LimitedLag", 2, 0, 10),
        lagResetDelay: setting.integer("LagResetDelay", 3000, 0, 10000),
        renderPath: setting.list("RenderPath", ["Off", "Box", "Guide", "Fusion"], "Box")
    };

    let targetList = [];
    let prevTargetList = [];

    const taskCount = new AtomicInteger(0);

    const updateTimer = new MSTimer();
    let updateDelay = 0;
    let attackKeyDown = false;

    const autoBlock = new AutoBlock();
    const selectors = new Selectors();

    const bufferedRenderPath = new BufferedRenderPath();
    const pathColor = new Color(0, 127, 255);

    const lagTimer = new MSTimer();
    let lagCount = 0;

    const tryReturnTimer = new MSTimer();
    let lastTeleportPos;
    let tryReturn;

    this.getName = function () {
        return "SimpleTPAura";
    }

    this.getDescription = function () {
        return "SimpleTPAura-Module, By-mumy";
    }

    this.getCategory = function () {
        return "Misc";
    }

    this.onEnable = function () {
        targetList = [];
        bufferedRenderPath.clear();
        selectors.reset();
        lagCount = 0;
        lastTeleportPos = null;
        tryReturn = null;
    }

    this.onDisable = function () {
        this.onEnable();
        autoBlock.reset();
    }

    this.onUpdate = function () {
        updateLagCount();
        bufferedRenderPath.update();
    }

    this.onMotion = function (event) {
        if (event.getEventState() !== EventState.PRE) {
            return;
        } if (!(taskCount.get() > 0)) {
            if (tryReturn != null && tryReturnTimer.hasTimePassed(settings.tryReturnDelay.get())) {
                tryBack();
                tryReturn = null;
                return;
            } if (settings.click.get()) {
                return;
            }
            selectors.select();
            if (updateTimer.hasTimePassed(updateDelay)) {
                update();
                updateTimer.reset();
                updateDelay = Math.floor(settings.delay.get());
            }
        }
        autoBlock.checkAndUpdate();
    }

    this.onRender3D = function (event) {
        updateClick();
        switch (settings.renderPath.get()) {
            case "Box":
                drawPathNode();
                break;
            case "Guide": {
                    const renderPathList = bufferedRenderPath.renderPathList;
                    for (let p = 0; p < renderPathList.length; ++p) {
                        const path = renderPathList[p];
                        drawNode(path[path.length - 1], pathColor);
                    }
                    drawPathLine();
                }
                break;
            case "Fusion":
                drawPathNode();
                drawPathLine();
                break;
        }
    }

    this.onPacket = function (event) {
        const packet = event.getPacket();
        if (packet instanceof S08PacketPlayerPosLook && settings.limitedLag.get() > 0) {
            ++lagCount;
            lagTimer.reset();
            if (!(lagCount < settings.limitedLag.get())) {
                moduleManager.getModule(this.getName()).setState(false);
                return;
            } if (settings.lagTryReturn.get()) {
                tryReturn = new TryReturnObject(packet, mc.thePlayer);
                tryReturnTimer.reset();
            }
        }
    }

    this.onWorld = function (event) {
        moduleManager.getModule(this.getName()).setState(false);
    }

    this.addValues = function (values) {
        for (let i in settings) {
            values.add(settings[i]);
        }
    }

    function updateLagCount() {
        const lagResetDelay = settings.lagResetDelay.get();
        if (lagCount > 0 && lagResetDelay > 0 && lagTimer.hasTimePassed(lagResetDelay)) {
            lagTimer.reset();
            --lagCount;
        }
    }

    function updateClick() {
        if (!settings.click.get() || taskCount.get() > 0) {
            return;
        } if (Mouse.isButtonDown(0)) {
            if (attackKeyDown) {
                return;
            }
            const entity = RaycastUtils.raycastEntity(128, isEnemy);
            if (entity != null) {
                execute(function () {
                    bufferedRenderPath.clearCache();
                    attackEntity(entity);
                    bufferedRenderPath.swapCache();
                });
            }
            attackKeyDown = true;
        } else {
            attackKeyDown = false;
        }
    }

    function update() {
        updateTarget();
        if (targetList.length === 0) {
            autoBlock.reset();
            return;
        } if (settings.autoBlock.get() !== "Off") {
            autoBlock.checkAndStart();
        }
        execute(function () {
            bufferedRenderPath.clearCache();
            const targets = settings.targets.get();
            const maximum = targets + 5;
            if (settings.targetMode.get() === "Normal") {
                let count = 0;
                for (let i = 0; i < targetList.length && i < maximum && count < targets; ++i) {
                    if (attackEntity(targetList[i])) {
                        ++count;
                    }
                }
            } else {
                for (let i = 0; i < targetList.length && i < maximum; ++i) {
                    const target = targetList[i];
                    if (attackEntity(target)) {
                        prevTargetList.push(target.getEntityId());
                        break;
                    }
                }
            }
        });
    }

    function updateTarget() {
        targetList = [];
        const entityList = mc.theWorld.loadedEntityList;
        const hurtTime = settings.hurtTime.get();
        const range = settings.range.get();
        const switchMode = settings.targetMode.get() === "Switch";
        if (!(prevTargetList.length < settings.targets.get())) {
            prevTargetList = [];
        } for (let i = 0; i < entityList.length; ++i) {
            const entity = entityList[i];
            if (!(entity.hurtResistantTime > hurtTime) && getDistanceToEntityBox(entity) < range && !(switchMode && prevTargetList.indexOf(entity.getEntityId()) !== -1) && isEnemy(entity) && !(settings.targetMode.get() === "Select" && !selectors.isSelected(entity))) {
                targetList.push(entity);
            }
        } if (targetList.length === 0) {
            if (switchMode && prevTargetList.length !== 0) {
                prevTargetList = [];
                updateTarget();
            }
            return;
        } for (let i = 0; i < 2; ++i) {
            switch (i === 0 ? settings.secondaryPriority.get() : settings.priority.get()) {
                case "Armor":
                    targetList.sort(function (a, b) {
                        return a.getTotalArmorValue() - b.getTotalArmorValue();
                    });
                    break;
                case "HurtTime":
                    targetList.sort(function (a, b) {
                        return a.hurtResistantTime - b.hurtResistantTime;
                    });
                    break;
                case "Health":
                    targetList.sort(function (a, b) {
                        return a.getHealth() - b.getHealth();
                    });
                    break;
                case "Distance":
                    targetList.sort(function (a, b) {
                        return getDistanceToEntityBox(a) - getDistanceToEntityBox(b);
                    });
                    break;
                case "Direction":
                    targetList.sort(function (a, b) {
                        return RotationUtils.getRotationDifference(a) - RotationUtils.getRotationDifference(b);
                    });
                    break;
                case "LivingTime":
                    targetList.sort(function (a, b) {
                        return b.ticksExisted - a.ticksExisted;
                    });
                    break;
            }
        }
    }

    function attackEntity(entity) {
        const netHandler = mc.getNetHandler();
        const player = mc.thePlayer;
        const target = entity instanceof EntityDragon ? entity.dragonPartBody : entity;
        const start = new Vec3(Math.floor(player.posX), Math.round(player.posY), Math.floor(player.posZ));
        const end = new Vec3(Math.floor(target.posX), Math.floor(target.posY), Math.floor(target.posZ));
        const path = findPath(end, start, player, target);
        if (path == null) {
            return false;
        }
        lastTeleportPos = end;
        const autoBlockMode = settings.autoBlock.get();
        const canBlock = autoBlockMode !== "Off";
        if (autoBlockMode !== "Vanilla") {
            autoBlock.checkAndStop();
        }
        const sneak = player.isSneaking() || moduleManager.getModule("Sneak").getState();
        if (sneak) {
            netHandler.addToSendQueue(new C0BPacketEntityAction(player, C0BPacketEntityAction.Action.STOP_SNEAKING));
        }
        const goPath = simplifyPath(path);
        if (settings.renderPath.get() !== "Off") {
            bufferedRenderPath.cachePathList.push(goPath);
            bufferedRenderPath.swapCache();
        }
        const ground = settings.spoofGround.get();
        for (let i = 0; i < goPath.length; ++i) {
            const node = goPath[i];
            netHandler.addToSendQueue(new C04PacketPlayerPosition(node.x + 0.5, ground ? Math.ceil((node.y + 0.0626) / 0.015625) * 0.015625 : node.y + 0.0626, node.z + 0.5, ground));
        } if (settings.aimTarget.get()) {
            const node = path[path.length - 1];
            const x = node.x + 0.5;
            const y = node.y + 0.0626 + player.getEyeHeight();
            const z = node.z + 0.5;
            const bb = target.getEntityBoundingBox();
            const diffX = x - Math.max(bb.minX, Math.min(x, bb.maxX));
            const diffY = y - Math.max(bb.minY, Math.min(y, bb.maxY));
            const diffZ = z - Math.max(bb.minZ, Math.min(z, bb.maxZ));
            const yaw = Math.toDegrees(Math.atan2(diffZ, diffX)) - 90;
            const pitch = -Math.toDegrees(Math.atan2(diffY, Math.sqrt(diffX * diffX + diffZ * diffZ)));
            const rotation = RotationUtils.serverRotation;
            netHandler.addToSendQueue(new C05PacketPlayerLook(rotation.getYaw() + (rotation.getYaw() - yaw), rotation.getPitch() + (rotation.getPitch() - pitch), ground));
        } if (settings.criticals.get()) {
            const node = path[path.length - 1];
            const x = node.x + 0.5;
            const y = node.y + 0.0626;
            const z = node.z + 0.5;
            netHandler.addToSendQueue(new C04PacketPlayerPosition(x, y + 0.0625, z, false));
            netHandler.addToSendQueue(new C04PacketPlayerPosition(x, y, z, false));
            netHandler.addToSendQueue(new C04PacketPlayerPosition(x, y + 0.0125, z, false));
            netHandler.addToSendQueue(new C04PacketPlayerPosition(x, y, z, false));
        } if (autoBlockMode === "Static") {
            autoBlock.checkAndStart();
        }
        LiquidBounce.eventManager.callEvent(new AttackEvent(target));
        if (settings.swing.get()) {
            player.swingItem();
        }
        netHandler.addToSendQueue(new C02PacketUseEntity(target, C02PacketUseEntity.Action.ATTACK));
        if (settings.returnTrip.get()) {
            if (autoBlockMode !== "Vanilla") {
                autoBlock.checkAndStop();
            }
            const backPath = simplifyPath(path.reverse());
            for (let i = 0; i < backPath.length; ++i) {
                const node = backPath[i];
                netHandler.addToSendQueue(new C04PacketPlayerPosition(node.x + 0.5, ground ? Math.ceil((node.y + 0.0626) / 0.015625) * 0.015625 : node.y + 0.0626, node.z + 0.5, ground));
            }
            netHandler.addToSendQueue(new C04PacketPlayerPosition(player.posX, player.posY, player.posZ, ground));
        } else {
            const node = path[path.length - 1];
            player.setPosition(node.x + 0.5, node.y + 0.0626, node.z + 0.5);
        } if (sneak) {
            netHandler.addToSendQueue(new C0BPacketEntityAction(player, C0BPacketEntityAction.Action.START_SNEAKING));
        } if (canBlock && autoBlockMode !== "Vanilla" || autoBlock.isPlayerBlocking()) {
            autoBlock.checkAndStart();
        }
        return true;
    }

    function findPath(start, end, player, entity) {

        const world = mc.theWorld;
        const mutableBlockPos = new MutableBlockPos();
        const throughWalls = settings.throughWalls.get();
        if (!check(end.x, end.y, end.z)) {
            for (let i = 1; i < settings.blinkDistance.get(); ++i) {
                if (check(end.x, end.y + i, end.z)) {
                    end.y += i;
                    break;
                }
            }
        } if (!throughWalls && !check(start.x, start.y, start.z)) {
            for (let i = 1; i < 4; ++i) {
                if (check(start.x, start.y + i, start.z)) {
                    start.y += i;
                    break;
                }
            }
        } if (!throughWalls && !check(start.x, start.y, start.z) || !check(end.x, end.y, end.z)) {
            return null;
        }
        const openList = new NodePriorityQueue();
        const closeList = new NodeSet();
        const startX = start.x;
        const startY = start.y;
        const startZ = start.z;
        const endX = end.x;
        const endY = end.y;
        const endZ = end.z;
        const compute = settings.compute.get();
        const vClip = settings.vClip.get();
        let specialNode = false;
        init();
        while (openList.size !== 0 && closeList.size < compute) {
            let node = openList.poll();
            const x = node.x;
            const y = node.y;
            const z = node.z;
            specialNode = false;
            if (closeList.contains(node)) {
                continue;
            } if (!checkNode(node)) {
                if (vClip) {
                    const parent = node.parent;
                    const parentX = parent.x;
                    const parentY = parent.y;
                    const parentZ = parent.z;
                    if (parentX === x && parentY === y && parentZ === z) {
                        continue;
                    }
                    let clip = false;
                    if (!check(parentX, parentY + 1, parentZ)) {
                        clip = true;
                        upVClip(parentX, parentY, parentZ, parent);
                    } if (!check(parentX, parentY - 1, parentZ)) {
                        clip = true;
                        downVClip(parentX, parentY, parentZ, parent);
                    } if (clip) {
                        closeList.put(node);
                    }
                }
                continue;
            } if (x === endX && y === endY && z === endZ) {
                const path = [];
                do {
                    path.push(node);
                    node = node.parent;
                } while (node != null);
                --path.length;
                return path;
            }
            closeList.put(node);
            if (!specialNode) {
                addToOpenList(x + 1, y, z, node);
                addToOpenList(x, y + 1, z, node);
                addToOpenList(x, y, z + 1, node);
                addToOpenList(x - 1, y, z, node);
                addToOpenList(x, y - 1, z, node);
                addToOpenList(x, y, z - 1, node);
            } else {
                reachable(x + 1, y, z, x, y, z) && addToOpenList(x + 1, y, z, node);
                reachable(x, y + 1, z, x, y, z) && addToOpenList(x, y + 1, z, node);
                reachable(x, y, z + 1, x, y, z) && addToOpenList(x, y, z + 1, node);
                reachable(x - 1, y, z, x, y, z) && addToOpenList(x - 1, y, z, node);
                reachable(x, y - 1, z, x, y, z) && addToOpenList(x, y - 1, z, node);
                reachable(x, y, z - 1, x, y, z) && addToOpenList(x, y, z - 1, node);
            }
        }
        return null;

        function init() {
            openList.add(new Node(startX, startY, startZ, new Node(startX, startY, startZ, null, 0, 0), 0, 0));
            if (throughWalls && entity != null) {
                for (let sX = -3; sX < 4; ++sX) {
                    for (let sY = -3; sY < 4; ++sY) {
                        for (let sZ = -3; sZ < 4; ++sZ) {
                            const x = startX + sX;
                            const y = startY + sY;
                            const z = startZ + sZ;
                            if (Math.pow(x + 0.5 - entity.posX, 2) + Math.pow(y + 0.0626 - entity.posY, 2) + Math.pow(z + 0.5 - entity.posZ, 2) < 8.5) {
                                const xDist = Math.abs(x - endX);
                                const yDist = Math.abs(y - endY);
                                const zDist = Math.abs(z - endZ);
                                const gCost = xDist + yDist + zDist;
                                const fCost = gCost + xDist + yDist + zDist + Math.sqrt(xDist * xDist + yDist * yDist + zDist * zDist);
                                openList.add(new Node(x, y, z, new Node(x, y, z, null, gCost, fCost), gCost, fCost));
                            }
                        }
                    }
                }
            }
        }

        function addToOpenList(x, y, z, parent) {
            const xDist = Math.abs(x - endX);
            const yDist = Math.abs(y - endY);
            const zDist = Math.abs(z - endZ);
            const gCost = parent.gCost + 1;
            const fCost = gCost + xDist + yDist + zDist + Math.sqrt(xDist * xDist + yDist * yDist + zDist * zDist);
            openList.add(new Node(x, y, z, parent, gCost, fCost));
        }

        function upVClip(x, y, z, parent) {
            const blinkDistance = parent.gCost !== 0 ? Math.floor(settings.blinkDistance.get()) + 1 : 3;
            for (let i = 2; i < blinkDistance; ++i) {
                const posY = y + i;
                if (check(x, posY, z)) {
                    const xDist = Math.abs(x - endX);
                    const yDist = Math.abs(posY - endY);
                    const zDist = Math.abs(z - endZ);
                    const gCost = parent.gCost + Math.abs(posY - y);
                    const fCost = gCost + xDist + yDist + zDist + Math.sqrt(xDist * xDist + yDist * yDist + zDist * zDist);
                    openList.add(new Node(x, posY, z, parent, gCost, fCost));
                    return;
                }
            }
        }

        function downVClip(x, y, z, parent) {
            const blinkDistance = parent.gCost !== 0 ? Math.floor(settings.blinkDistance.get()) + 1 : 3;
            for (let i = 3; i < blinkDistance; ++i) {
                const posY = y - i;
                if (check(x, posY, z)) {
                    const xDist = Math.abs(x - endX);
                    const yDist = Math.abs(posY - endY);
                    const zDist = Math.abs(z - endZ);
                    const gCost = parent.gCost + Math.abs(posY - y);
                    const fCost = gCost + xDist + yDist + zDist + Math.sqrt(xDist * xDist + yDist * yDist + zDist * zDist);
                    openList.add(new Node(x, posY, z, parent, gCost, fCost));
                    return;
                }
            }
        }

        function check(x, y, z) {
            return passable(x, y, z) && passable(x, y + 1, z) && groundPassable(x, y - 1, z) || special(x, y, z) && reachable(x, y, z, x, y, z);
        }

        function checkNode(node) {
            const x = node.x;
            const y = node.y;
            const z = node.z;
            if (passable(x, y, z) && passable(x, y + 1, z) && groundPassable(x, y - 1, z)) {
                return true;
            } if (special(x, y, z)) {
                specialNode = true;
                const parent = node.parent;
                const parentX = parent.x;
                const parentY = parent.y;
                const parentZ = parent.z;
                return reachable(x, y, z, parentX, vClip && Math.abs(parentY - y) > 1 ? y : parentY, parentZ);
            }
            return false;
        }

        function passable(x, y, z) {
            const blockState = world.getBlockState(mutableBlockPos.set(x, y, z));
            const block = blockState.getBlock();
            return block.getCollisionBoundingBox(world, mutableBlockPos, blockState) == null && !((block instanceof BlockLiquid || block instanceof BlockStaticLiquid) && block.getMaterial() !== Material.water);
        }

        function groundPassable(x, y, z) {
            const blockState = world.getBlockState(mutableBlockPos.set(x, y, z));
            const block = blockState.getBlock();
            return block.getCollisionBoundingBox(world, mutableBlockPos, blockState) == null || !(block instanceof BlockFence || block instanceof BlockWall || block instanceof BlockFenceGate);
        }

        function special(x, y, z) {
            const blockPos = mutableBlockPos.set(x, y, z);
            const block = world.getBlockState(blockPos).getBlock();
            const blockRegistry = Block.blockRegistry;
            return block instanceof BlockLadder || block instanceof BlockCarpet || block instanceof BlockSnow && block.isReplaceable(world, blockPos) || block === blockRegistry.getObjectById(111) || block instanceof BlockTrapDoor || block instanceof BlockDoor;
        }

    }

    function simplifyPath(path) {
        const blinkDistance = settings.blinkDistance.get();
        if (blinkDistance > 0 && !(blinkDistance > 1)) {
            return interpolatePath(path);
        }
        const finalPath = [path[0]];
        let finalNode = path[0];
        let index = 0;
        let flag = false;
        const vClip = settings.vClip.get();
        for (;;) {
            if (index < path.length) {
                const node = path[index];
                const xDist = finalNode.x - node.x;
                const yDist = finalNode.y - node.y;
                const zDist = finalNode.z - node.z;
                if (blinkDistance > 0 && xDist * xDist + yDist * yDist + zDist * zDist > blinkDistance * blinkDistance) {
                    flag = true;
                } if (!flag && (!vClip || xDist !== 0 || zDist !== 0)) {
                    if (!reachable(finalNode.x, finalNode.y, finalNode.z, node.x, node.y, node.z)) {
                        flag = true;
                    }
                } if (flag) {
                    --index;
                    finalPath.push(path[index]);
                    finalNode = path[index];
                    flag = false;
                }
                ++index;
            } else {
                finalPath.push(path[index - 1]);
                return finalPath;
            }
        }
    }

    function interpolatePath(path) {
        const blinkDistance = settings.blinkDistance.get();
        if (!(blinkDistance < 1)) {
            return path;
        }
        const finalPath = [path[0]];
        for (let i = 1; i < path.length; ++i) {
            const node = path[i];
            const prevNode = path[i - 1];
            const xDist = node.x - prevNode.x;
            const yDist = node.y - prevNode.y;
            const zDist = node.z - prevNode.z;
            const distance = Math.sqrt(xDist * xDist + yDist * yDist + zDist * zDist);
            const step = Math.ceil(distance / blinkDistance);
            if (step > 1) {
                for (let s = 1; s < step; ++s) {
                    finalPath.push(new Vec3(prevNode.x + xDist / step * s, prevNode.y + yDist / step * s, prevNode.z + zDist / step * s));
                }
                finalPath.push(node);
            }
        }
        return finalPath;
    }

    function reachable(x, y, z, x2, y2, z2) {

        const world = mc.theWorld;
        const boxList = new ArrayList(16);
        const mutableBlockPos = new MutableBlockPos();
        const yBB = new AxisAlignedBB(x + 0.5 - 0.3, (y2 < y ? y2 : y) + 0.0626, z + 0.5 - 0.3, x + 0.5 + 0.3, (y2 > y ? y2 : y) + 1.8 + 0.0626, z + 0.5 + 0.3);
        for (;;) {
            if (intersects(yBB, x, y, z)) {
                return false;
            } if (y === y2) {
                if (intersects(yBB, x, y + (y > y2 ? -1 : 1), z)) {
                    return false;
                }
                break;
            } if (y > y2) {
                --y;
            } else {
                ++y;
            }
        }
        const xBB = new AxisAlignedBB((x2 < x ? x2 : x) + 0.5 - 0.3, y2 + 0.0626, z + 0.5 - 0.3, (x2 > x ? x2 : x) + 0.5 + 0.3, y2 + 1.8 + 0.0626, z + 0.5 + 0.3);
        for (;;) {
            if (intersects(xBB, x, y, z) || intersects(xBB, x, y + 1, z) || intersects(xBB, x, y - 1, z)) {
                return false;
            } if (x === x2) {
                break;
            } if (x > x2) {
                --x;
            } else {
                ++x;
            }
        }
        const zBB = new AxisAlignedBB(x2 + 0.5 - 0.3, y2 + 0.0626, (z2 < z ? z2 : z) + 0.5 - 0.3, x2 + 0.5 + 0.3, y2 + 1.8 + 0.0626, (z2 > z ? z2 : z) + 0.5 + 0.3);
        for (;;) {
            if (intersects(zBB, x, y, z) || intersects(zBB, x, y + 1, z) || intersects(zBB, x, y - 1, z)) {
                return false;
            } if (z === z2) {
                break;
            } if (z > z2) {
                --z;
            } else {
                ++z;
            }
        }
        return true;

        function intersects(bb, x, y, z) {
            const blockState = world.getBlockState(mutableBlockPos.set(x, y, z));
            const size = boxList.size();
            blockState.getBlock().addCollisionBoxesToList(world, mutableBlockPos, blockState, bb, boxList, null);
            return size !== boxList.size();
        }

    }

    function getDistanceToEntityBox(entity) {
        const player = mc.thePlayer;
        const bb = entity.getEntityBoundingBox();
        const eyeX = player.posX;
        const eyeY = player.posY + player.getEyeHeight();
        const eyeZ = player.posZ;
        const xDist = eyeX - Math.max(bb.minX, Math.min(eyeX, bb.maxX));
        const yDist = eyeY - Math.max(bb.minY, Math.min(eyeY, bb.maxY));
        const zDist = eyeZ - Math.max(bb.minZ, Math.min(eyeZ, bb.maxZ));
        return Math.sqrt(xDist * xDist + yDist * yDist + zDist * zDist);
    }

    function isEnemy(entity) {

        if (entity instanceof EntityLivingBase && (EntityUtils.targetDead || entity.isEntityAlive() && entity.getHealth() > 0) && entity !== mc.thePlayer) {
            if (!EntityUtils.targetInvisible && entity.isInvisible()) {
                return false
            } if (EntityUtils.targetPlayer && entity instanceof EntityPlayer) {
                if (entity.isSpectator() || AntiBot.isBot(entity)) {
                    return false
                } if (isFriend(entity) && !moduleManager.getModule("NoFriends").getState()) {
                    return false;
                }
                const teams = LiquidBounce.moduleManager.getModule("Teams");
                return !teams.getState() || !teams.isInYourTeam(entity);
            }
            return EntityUtils.targetMobs && isMob(entity) || EntityUtils.targetAnimals && isAnimal(entity);
        }
        return false;

        function isAnimal(entity) {
            return entity instanceof EntityAnimal || entity instanceof EntitySquid || entity instanceof EntityGolem || entity instanceof EntityBat;
        }

        function isFriend(entity) {
            return entity instanceof EntityPlayer && entity.getName() != null && LiquidBounce.fileManager.friendsConfig.isFriend(ColorUtils.stripColor(entity.getName()));
        }

        function isMob(entity) {
            return entity instanceof EntityMob || entity instanceof EntityVillager || entity instanceof EntitySlime || entity instanceof EntityGhast || entity instanceof EntityDragon;
        }

    }

    function execute(func) {
        taskCount.incrementAndGet();
        threadPool.execute(function () {
            try {
                func();
            } catch (err) {
                chat.print(err);
            }
            taskCount.decrementAndGet();
        });
    }

    function tryBack() {
        bufferedRenderPath.clearCache();
        const player = mc.thePlayer;
        const start = tryReturn.start;
        const end = tryReturn.end;
        const path = findPath(end, start, player, null);
        if (path == null) {
            return;
        }
        const netHandler = mc.getNetHandler();
        const sneak = player.isSneaking() || moduleManager.getModule("Sneak").getState();
        if (sneak) {
            netHandler.addToSendQueue(new C0BPacketEntityAction(player, C0BPacketEntityAction.Action.STOP_SNEAKING));
        }
        const goPath = simplifyPath(path);
        if (settings.renderPath.get() !== "Off") {
            bufferedRenderPath.cachePathList.push(goPath);
            bufferedRenderPath.swapCache();
        }
        const ground = settings.spoofGround.get();
        for (let i = 0; i < goPath.length; ++i) {
            const node = goPath[i];
            netHandler.addToSendQueue(new C04PacketPlayerPosition(node.x + 0.5, ground ? Math.ceil((node.y + 0.0626) / 0.015625) * 0.015625 : node.y + 0.0626, node.z + 0.5, ground));
        }
    }

    function drawNode(node, color) {
        const renderManager = mc.getRenderManager();
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        RenderUtils.enableGlCap(GL11.GL_BLEND);
        RenderUtils.disableGlCap(GL11.GL_TEXTURE_2D, GL11.GL_DEPTH_TEST);
        GL11.glDepthMask(false);
        RenderUtils.glColor(color.getRed(), color.getGreen(), color.getBlue(), 26);
        const axisAlignedBB = new AxisAlignedBB(
            node.x - renderManager.renderPosX,
            node.y - renderManager.renderPosY,
            node.z - renderManager.renderPosZ,
            node.x + 1 - renderManager.renderPosX,
            node.y + 1 - renderManager.renderPosY,
            node.z + 1 - renderManager.renderPosZ);
        RenderUtils.drawFilledBox(axisAlignedBB);
        GL11.glLineWidth(1);
        RenderUtils.enableGlCap(GL11.GL_LINE_SMOOTH);
        RenderUtils.glColor(color.getRed(), color.getGreen(), color.getBlue(), 95);
        RenderUtils.drawSelectionBoundingBox(axisAlignedBB);
        GlStateManager.resetColor();
        GL11.glDepthMask(true);
        RenderUtils.resetCaps();
    }

    function drawPathNode() {
        const renderPathList = bufferedRenderPath.renderPathList;
        for (let p = 0; p < renderPathList.length; ++p) {
            const path = renderPathList[p];
            for (let i = 0; i < path.length; ++i) {
                drawNode(path[i], pathColor);
            }
        }
    }

    function drawPathLine() {
        const renderManager = mc.getRenderManager();
        const viewerPosX = renderManager.viewerPosX;
        const viewerPosY = renderManager.viewerPosY;
        const viewerPosZ = renderManager.viewerPosZ;
        const renderPathList = bufferedRenderPath.renderPathList;
        for (let p = 0; p < renderPathList.length; ++p) {
            const path = renderPathList[p];
            GL11.glPushMatrix();
            GL11.glDisable(GL11.GL_TEXTURE_2D);
            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
            GL11.glEnable(GL11.GL_LINE_SMOOTH);
            GL11.glEnable(GL11.GL_BLEND);
            GL11.glDisable(GL11.GL_DEPTH_TEST);
            mc.entityRenderer.disableLightmap();
            GL11.glBegin(GL11.GL_LINE_STRIP);
            RenderUtils.glColor(pathColor);
            let node = path[0];
            let prev;
            GL11.glVertex3d(node.x + 0.5 - viewerPosX, node.y - viewerPosY, node.z + 0.5 - viewerPosZ);
            for (let i = 1; i < path.length; ++i) {
                prev = node;
                node = path[i];
                GL11.glVertex3d(prev.x + 0.5 - viewerPosX, node.y - viewerPosY, prev.z + 0.5 - viewerPosZ);
                GL11.glVertex3d(node.x + 0.5 - viewerPosX, node.y - viewerPosY, prev.z + 0.5 - viewerPosZ);
                GL11.glVertex3d(node.x + 0.5 - viewerPosX, node.y - viewerPosY, node.z + 0.5 - viewerPosZ);
            }
            GL11.glColor4d(1, 1, 1, 1);
            GL11.glEnd();
            GL11.glEnable(GL11.GL_DEPTH_TEST);
            GL11.glDisable(GL11.GL_LINE_SMOOTH);
            GL11.glDisable(GL11.GL_BLEND);
            GL11.glEnable(GL11.GL_TEXTURE_2D);
            GL11.glPopMatrix();
        }
    }

    function TryReturnObject(packet, player) {
        this.start = new Vec3(Math.floor(packet.getX()), Math.floor(packet.getY()), Math.floor(packet.getZ()));
        this.end = lastTeleportPos || new Vec3(Math.floor(player.posX), Math.floor(player.posY), Math.floor(player.posZ));
    }

    function Node(x, y, z, parent, gCost, fCost) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.parent = parent;
        this.gCost = gCost;
        this.fCost = fCost;
    }

    function Vec3(x, y, z) {
        this.x = x;
        this.y = y;
        this.z = z;
    }

    function NodeSet() {

        const length = 1 << 16;
        const mod = length - 1;
        const array = new Array(length);
        this.size = 0;

        this.put = function (node) {
            const hash = Math.abs((node.y + node.z * 31) * 31 + node.x) & mod;
            if (array[hash] == null) {
                array[hash] = new Node(node, null);
            } else {
                const current = array[hash];
                let temp = current;
                do {
                    if (equals(temp.value, node)) {
                        return;
                    }
                    temp = temp.next;
                } while (temp != null);
                array[hash] = new Node(node, current);
            }
            ++this.size;
        }

        this.contains = function (node) {
            const hash = Math.abs((node.y + node.z * 31) * 31 + node.x) & mod;
            if (array[hash] != null) {
                let temp = array[hash];
                do {
                    if (equals(temp.value, node)) {
                        return true;
                    }
                    temp = temp.next;
                } while (temp != null);
            }
            return false;
        }

        this.get = function (node) {
            const hash = Math.abs((node.y + node.z * 31) * 31 + node.x) & mod;
            if (array[hash] != null) {
                let temp = array[hash];
                do {
                    if (equals(temp.value, node)) {
                        return temp.value;
                    }
                    temp = temp.next;
                } while (temp != null);
            }
            return null;
        }

        function equals(a, b) {
            return a.x === b.x && a.y === b.y && a.z === b.z;
        }

        function Node(value, next) {
            this.value = value;
            this.next = next;
        }

    }

    function NodePriorityQueue() {

        const instance = this;
        const queue = new Array(64);
        this.size = 0;

        this.add = function (node) {
            queue[this.size] = node;
            ++this.size;
            siftUp();
        }

        this.poll = function () {
            --this.size;
            const top = queue[0];
            queue[0] = queue[this.size];
            siftDown();
            return top;
        }

        function siftUp() {
            let hold = instance.size - 1;
            const node = queue[hold];
            while (hold > 0) {
                const root = (hold - 1) >>> 1;
                const parent = queue[root];
                if (!(parent.fCost > node.fCost)) {
                    break;
                }
                queue[hold] = parent;
                hold = root;
            }
            queue[hold] = node;
        }

        function siftDown() {
            let hold = 0;
            const size = instance.size;
            const half = size >>> 1;
            const node = queue[hold];
            while (hold < half) {
                let child = (hold << 1) + 1;
                const right = child + 1;
                if (right < size && queue[right].fCost < queue[child].fCost) {
                    child = right;
                } if (!(queue[child].fCost < node.fCost)) {
                    break;
                }
                queue[hold] = queue[child];
                hold = child;
            }
            queue[hold] = node;
        }

    }

    function AutoBlock() {

        this.change = false;
        this.status = false;
        const blockPos = new BlockPos(-1, -1, -1);

        this.start = function () {
            this.change = true;
            this.status = true;
            const player = mc.thePlayer;
            player.setItemInUse(player.inventory.getCurrentItem(), 51213);
            mc.getNetHandler().addToSendQueue(new C08PacketPlayerBlockPlacement(blockPos, 255, player.inventory.getCurrentItem(), 0, 0, 0));
            KeyBinding.setKeyBindState(mc.gameSettings.keyBindUseItem.getKeyCode(), true);
        }

        this.stop = function () {
            this.change = true;
            this.status = false;
            mc.getNetHandler().addToSendQueue(new C07PacketPlayerDigging(C07PacketPlayerDigging.Action.RELEASE_USE_ITEM, blockPos, EnumFacing.DOWN));
            mc.thePlayer.stopUsingItem();
            KeyBinding.setKeyBindState(mc.gameSettings.keyBindUseItem.getKeyCode(), false);
        }

        this.checkAndStop = function () {
            if (mc.thePlayer.isBlocking()) {
                this.stop();
            }
        }

        this.checkAndStart = function () {
            if (!mc.thePlayer.isBlocking() && itemIsSword()) {
                this.start();
            }
        }

        this.checkAndUpdate = function () {
            if (this.status && !itemIsSword() && !GameSettings.isKeyDown(mc.gameSettings.keyBindUseItem)) {
                this.stop();
            }
        }

        this.reset = function () {
            if (!this.change) {
                return;
            } if (this.status && !GameSettings.isKeyDown(mc.gameSettings.keyBindUseItem)) {
                this.stop();
            }
            this.change = false;
        }

        this.isPlayerBlocking = function () {
            return GameSettings.isKeyDown(mc.gameSettings.keyBindUseItem) && itemIsSword();
        }

        function itemIsSword() {
            const heldItem = mc.thePlayer.getHeldItem();
            return heldItem != null && heldItem.getItem() instanceof ItemSword;
        }

    }


    function Selectors() {

        this.entityID = -1;

        this.select = function () {
            if (!Mouse.isButtonDown(2)) {
                return;
            }
            const entity = RaycastUtils.raycastEntity(128, isEnemy);
            if (entity != null) {
                this.entityID = entity.getEntityId();
            }
        }

        this.isSelected = function (entity) {
            return entity.getEntityId() === this.entityID;
        }

        this.reset = function () {
            this.entityID = -1;
        }

    }

    function BufferedRenderPath() {

        let updateTimer = new MSTimer();

        this.renderPathList = [];
        this.cachePathList = [];

        this.clearCache = function () {
            this.cachePathList = [];
        }

        this.clear = function () {
            this.renderPathList = [];
            this.cachePathList = [];
        }

        this.swapCache = function () {
            this.renderPathList = this.cachePathList;
            updateTimer.reset();
        }

        this.update = function () {
            if (this.renderPathList.length !== 0 && updateTimer.hasTimePassed(500)) {
                this.renderPathList = [];
            }
        }

    }

}

Math.toRadians = function (degrees) {
    return degrees * Math.PI / 180;
}

Math.toDegrees = function (radians) {
    return radians * 180 / Math.PI;
}

let client;

function onLoad() {}

function onEnable() {
    threadPool = Executors.newFixedThreadPool(2);
    client = moduleManager.registerModule(new SimpleTPAura());
}

function onDisable() {
    threadPool.shutdown();
    moduleManager.unregisterModule(client);
}

